/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/index.php?title=User:Seb76> for more details.
 * Copyright (C) 2008-2010 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "patcher.h"
#include "patches.h"
#include "xcom.h"

#include "roswell.h"
#include "smoke.h"
#include "hacks.h"
#include "base.h"
#include "music.h"
#include "heavylaser.h"
#include "stun.h"
#include "video.h"

/*
 * TODO:
 *  -ammo weight bug in inventory
 *  -base defense reset retaliation flag
 *  -psi attacks target random soldier
 *  -mind controlled soldiers at the end become MIA
 *  -more realistic grenade fuse
 *
 *  -link to full stats in inventory
 *  -80 items limit??
 */


/*
 * Make visible the presence of the loader
 */
void ShowMod()
{
	DrawString("All your base are belong to us",0x8B,52,88,1);
	((void (*)(int))(0x42F680))(1);
}



/*
 * Equipment screen mod
 */
void ShowEncumberance(void)
{
	int encumberance=GetUnitEncumberance(*unitIdx);
	unsigned char strength=(*currentUnit_pUnitRef)->Strength;
	unsigned char accuracy=(*currentUnit_pUnitRef)->Firing_Acc;
	unsigned char reaction=(*currentUnit_pUnitRef)->React_Current;
	unsigned char psi_strength=(*currentUnit_pUnitRef)->Psi_Strength;
	unsigned char psi_skill=(*currentUnit_pUnitRef)->Psi_Skill;

	static char weight_str[16];
	static char accuracy_str[16];
	static char reaction_str[16];
	static char psi_strength_str[16];
	static char psi_skill_str[16];
	static int init=0;
	if(init==0) {
		init=1;
		INI_READ_STRING("Equipment Screen","Weight","Weight>",weight_str,16);
		INI_READ_STRING("Equipment Screen","Accuracy","Accur>",accuracy_str,16);
		INI_READ_STRING("Equipment Screen","Reaction","React>",reaction_str,16);
		INI_READ_STRING("Equipment Screen","Psi Strength","P.Str>",psi_strength_str,16);
		INI_READ_STRING("Equipment Screen","Psi Skill","P.Skill>",psi_skill_str,16);
	}

	//Draw weight stats
	DrawString(weight_str,0x40,24,245,1);
	if(encumberance>strength)
		DrawNumber(encumberance,0x20,*carretPosition,1);
	else
		DrawNumber(encumberance,0x10,*carretPosition,1);

	DrawSmallLetter('/',0x40,*carretPosition);
	DrawNumber(strength,0x30,*carretPosition,1);

	//Only draw other stats during equiping phase
	if(*tactical_mainState != 2)
	{
		DrawString(accuracy_str,0x40,32,245,1);
		DrawNumber(accuracy,0x10,*carretPosition,1);

		DrawString(reaction_str,0x40,40,245,1);
		DrawNumber(reaction,0x10,*carretPosition,1);

		//Only draw psi stats when unit has been in psi-lab
		if(psi_skill)
		{
			DrawString(psi_skill_str,0x40,48,245,1);
			DrawNumber(psi_skill,0x10,*carretPosition,1);

			DrawString(psi_strength_str,0x40,56,245,1);
			DrawNumber(psi_strength,0x10,*carretPosition,1);
		}
	}
}

/*
 * The procedure that randomizes the shots trajectory is bugged when shooting vertically.
 * We disable it when it is the case to fix the blaster bomb bug.
 */
void FixedAccuracyCompensation()
{
	short x1=*(short *)0x4783F8;
	short y1=*(short *)0x4783FA;
	short x2=*(short *)0x478400;
	short y2=*(short *)0x478402;

	if( x1 == x2 && y1 == y2 ) //vertical shot
		return;

	AdjustShotWithAccuracy();
}

/*
 * Called when scrolling in tactical mode. This reduces the scroll speed
 */
void TimeFix(int eax)
{
	DWORD tac_time,delta;
	tac_time=timeGetTime();
	((void (*)(int))(0x428970))(eax);
	delta=timeGetTime()-tac_time;

	if(delta<20)
	{
		Sleep(20-delta);
	}
}



/*
 * TU reservation mode
 * We save the mode when ending turn and restore it
 * before the next human turn
 */
static short savedReservedMode=0;
void SaveReserveMode()
{
	savedReservedMode=*tac_currentTUReserveMode;
}
void RestoreReserveMode()
{
	*tac_currentTUReserveMode=savedReservedMode;
}

/*
 * Detect successful ground assault missions and trigger reaction from alien
 */
void RetaliationAfterGroundAssault(void *dstbuf, int filename)
{
	char victoryStatus;
	LoadFile(dstbuf,filename);
	victoryStatus=tac_misdata[0x4e];

	if(victoryStatus == 1) //mission successful
	{
		char locIdx=tac_misdata[0x4c];
		if( ((*locationList+20*locIdx))[0] == 1 ) //Landed UFO have type 1 here, not 6!!!
		{
			char ufoIdx=(*locationList+20*locIdx)[1];
			char craftIdx=tac_misdata[0x4d];
			void *attacker=(void *)(*craftList+104*craftIdx);
			void *ufo=(void *)(*craftList+104*ufoIdx);
			AlienTakeActionAfterShootDown(ufo,attacker);
		}
	}
}

/*
 * Wreck analysis
 * Each navigation module can provide zone and/or mission data
 * The probability may need some tweaking
 */
void WreckAnalysis(int number, int color, __int16 ypos, __int16 xpos, int useSmallFonts)
{
	DrawNumber2(number, color, ypos, xpos, useSmallFonts);

	int recoveredNavigation=tac_misdata[2];
	int i;
	int discoverZone=0;
	int discoverMission=0;
	char buf[256];
	char format[256];

#ifndef NDEBUG
	discoverZone=1;
	discoverMission=1;
#endif

	char victoryStatus=tac_misdata[0x4e];
	char missionDescriptor=tac_misdata[0x14];

	//Only work on successful ground missions
	if(victoryStatus != 1 && missionDescriptor != 0 )
		return;

	//"analyze" each navigation module
	for(i=0;i<recoveredNavigation;i++)
	{
		if(GetRandom_0_n(100)<20-*difficultyLevel*2)
		{
			discoverZone=1;
		}
		if(GetRandom_0_n(100)<20-*difficultyLevel*2)
		{
			discoverMission=1;
		}
	}


	char locIdx=tac_misdata[0x4c];
	char ufoIdx=(*locationList+20*locIdx)[1];
	int type=(*craftList+104*ufoIdx)[28];
	int zone=(*craftList+104*ufoIdx)[30];
	int race=(*craftList+104*ufoIdx)[36];
	
	char *missionName=StringTable_geoscape[558+type];
	char *zoneName=StringTable_geoscape[543+zone];
	char *raceName=StringTable_geoscape[466+race];


	if(discoverMission&&discoverZone)
	{
		INI_READ_STRING("Wreck Analysis","Both Discovered","Ship investigation revealed that the %s UFO was on an %s mission in %s",format,256);
		sprintf(buf,format,raceName,missionName,zoneName);
	}
	else if(discoverMission)
	{
		INI_READ_STRING("Wreck Analysis","Mission Discovered","Inspection showed that the %s UFO was on an %s mission",format,256);
		sprintf(buf,format,raceName,missionName);
	}
	else if(discoverZone)
	{
		INI_READ_STRING("Wreck Analysis","Zone Discovered","Intel found out that the %s UFO was raiding %s",format,256);
		sprintf(buf,format,raceName,zoneName);
	}
	else
	{
		return;
	}

	*DrawText_rightBorder=320-16;
	DrawString(buf,0x8b,ypos+16,16,1);
}


/*
 * Draw the rank icon in the equipment screen
 */
void DrawRank(char *str, int color, __int16 ypos, __int16 xpos, int smallFont)
{
	DrawString(str,color,ypos,xpos+32,smallFont);
	char **unitref=(char **)0x4783C4;
	if((*unitref)[0]>2) //aliens have no rank icons
		return;

	int rank=(*unitref)[0x2a];
	short oldGFX=*currentGFXPackage;

	LoadGFXRessources(1);
	
	char *icon=*smokePCKRessources+*(*smokeTabRessources+20+rank);
	DrawRankIcon((int)*BackBuffer,(int)icon,32);
#if 0
	if(*mouse_num_click1&&*mouse_xpos<32&&*mouse_ypos<32)
	{
		short saved_state=*tactical_mainState;
		char fb[320*200];
		memcpy(fb,*BackBuffer,320*200);
		*mouse_num_click1=0;
		LoadGFXRessources(3);
//		ShowSoldierStats(*currentUnit_pUnitPos);
		ShowSoldierStats(*(char **)0x4783C0);

		/*
		((void (*)(int))(0x42F680))(1);
		((void (*)())(0x412C80))();

		while(!*mouse_buttons);
		{
			((void (*)())(0x42FDD0))();
		}
		
		*tactical_mainState=saved_state;
		memcpy(*BackBuffer,fb,320*200);
*/
	}
#endif
	LoadGFXRessources(oldGFX);
}


/*
 * Trigger reaction fire when units turn
 * The two functions are called when the unit's orientation change
 */
void ReactionFire1()
{
	((void (*)())(0x42DD50))();
	__asm pusha
	if(*isDuringReactionFire == 0)
		PerformReactionFire();
	__asm popa
}

void ReactionFire2(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance)
{
	ComputeVisibleAliens(xpos, ypos, zpos, orientation, distance);
	__asm pusha
	if(*isDuringReactionFire == 0)
		PerformReactionFire();
	__asm popa
}


/*
 * Repopulate the activated proximity grenade list during each loop of the battlescape.
 * This is crude but effective. As an added bonus, it reduces the speed of the game ;-)
 * Better solution would be to update it only during unit movement.
 */
void FixProximityMines()
{
	__asm push ecx
	for(int i=0;i<20;i++) {
		tac_prox_mine_list[i].active=0;
	}
	int mine_idx=0;

	for(int i=0;i<170;i++)
	{
//		unsigned char *pObpos=&pObpos_dat[i*16];
		obpos_dat *pObpos=&pObpos_dat[i];
//		if(pObpos[0]==0x15&&pObpos[8]==1&&pObpos[4]==-1) //armed prox mine on the ground
		if(pObpos->itemType==0x15&&pObpos->quantity1==1&&pObpos->owner==0xff) //armed prox mine on the ground
		{
			tac_prox_mine_list[mine_idx].active=1;
			tac_prox_mine_list[mine_idx].pObpos=pObpos;
			mine_idx++;
			if(mine_idx==20)
				break;
		}
	}

	__asm pop ecx
	ActAccordingToTacticalState();
}

/*
 * Explosions give experience to the "current unit". For proxmines, developers forget to change it before generating
 * the explosion and the experience does not go to the correct unit.
 */
void FixProximityMinesExperience(int xpos, int ypos, __int16 zpos, int strength, int a, int b, __int16 c)
{
	unsigned char *pObpos;
	unsigned char thrower_idx;
	
	//save the current unit
	short saved_idx=*currentUnit_idx;

	__asm 
	{
		mov eax,[esi+2];
		mov pObpos,eax;
	}

	//set current unit to the thrower
	thrower_idx=pObpos[9];
	SetCurrentUnit(thrower_idx);
	
	//boom!
	GenerateExplosion(xpos, ypos, zpos, strength, a, b, c);

	//restore the current unit
	SetCurrentUnit(saved_idx);
}

/*
 * Helper to draw dialog boxes
 */
void DrawDialog(char *line1, char *line2)
{
	//Draw box
	((void (*)(int,int,int,int,int))(0x41E3F0))(0x30,0x32,0x58,0xDC,1);


	*DrawText_leftBorder=0xA0;
	DrawString(line1,0x10,0x40,0x50,0);
	*DrawText_leftBorder=0xA0;
	DrawString(line2,0x10,0x50,0x50,0);
	*ui_numButtons=0;

	//"OK" button
	CreateButton(0x70,0x64,0x12,0x78,0x10,StringTable_battlescape[77]);

	((void (*)(int))(0x42F680))(1);

	WaitTillMouseButtonsAreReleased();
	while(!CheckForClickedButton());
}

/*
 * Elerium ships have a constant consumption rate of 1 (for standard ship, consumption is based on ship speed).
 * This rate is used at 2 places: to know when the ship has burnt half its fuel, and to determine how much distance
 * it can still fly. The second part is buggy however and uses the standard ship formula so we end up with a fly distance
 * of 0 and the ship returns immedialty. This should fix the issue.
 */
__declspec(naked) void EleriumShipFix()
{
	__asm
	{
		mov eax,edi
		cdq
		
		cmp bl,0
		jz std_fuel
		cmp bl,3
		jz std_fuel
		ret
std_fuel:
		idiv ecx
		ret
	}
}

/*
 * Call the KillUnit function when an unconscious corpse is destroyed.
 * The KillUnit function generates a body and we don't want that. To prevent
 * it, we find which obpos will be used for the body (gotten with GetFreeObPosRef)
 * and clear the object after we called the function. Since big units can use
 * 4 objects, we check the 4 next obpos.
 */
void ObjectDestroyed(unsigned char *pObpos)
{
	int flags=pObpos[12];
	if(flags&8) //unconscious corpse
	{
		int obtype=pObpos[0];
		if(obtype>=58&&obtype<=77) //big units: get out
			return;

		short corpse[4];
		int unitidx=pObpos[8];
		char *unitpos=&(unitpos_dat)[14*unitidx];
		char *unitref=*(char **)&(unitpos[4]);

		//save the next 4 free obpos
		for(int i=0;i<4;i++)
		{
			corpse[i]=GetFreeObPosRef();
		}

		Tactical_KillUnit(unitidx);

		//clear the obpos since they contain body objects
		for(int i=0;i<4;i++)
		{
			if(corpse[i]!=-1)
				pObpos_dat[corpse[i]].ypos=0xff;
		}

		DrawDialog(&unitref[0x56],"got blasted");
	}
}

//Call the ObjectDestroyed function instead of just destroying the object by clearing its objType field
__declspec(naked) void CheckDestroyObject()
{
	__asm
	{
		jbe skip
		pusha
			
		sub esi,6
		push esi
		call ObjectDestroyed
		add esp,4

		popa
		mov     [esi-6], bl
skip:
		ret
	}
}



const char *GetObjectDescription(const char *defaultDescription)
{
	unsigned char *pObpos=(unsigned char *)&pObpos_dat[*inventory_draggedItem_obPosIdx];
	static int init;
	static char primed[32];
	if(init==0) {
		init=1;
		INI_READ_STRING("Equipment Screen","Primed","primed",primed,16);
	}

	switch(*inventory_draggedItem_objectType)
	{
	case 0x13://grenade
	case 0x14://smoke
	case 0x16://HE
	case 0x2c://alien grenade
	case 0x15://proximity
		if(pObpos[8]!=0)//quantity1
		{
			static char str[128];
			sprintf(str,"%s (%s)",defaultDescription,primed);
			return str;
		}
		//fall through
	default:
		return defaultDescription;
	}
}

__declspec(naked) void GrenadeState(void)
{
	static int saved;
	__asm
	{
		mov edx, [0x49D660+ecx*4]
		pusha
		push edx
		call GetObjectDescription
		add esp,4
		mov saved,eax
		popa
		mov edx, saved
		ret
	}
}




static int draw_accuracy=0;
static int current_efficiency;
static int minimum_efficiency;
static int snap_penalty_distance;
static int auto_penalty_distance;
static int orange_cursor_limit;
static int red_cursor_limit;
void LoadAccuracyParameters()
{
	minimum_efficiency=INI_READ_INT("Range Based Accuracy","Minimum Efficiency",50);
	snap_penalty_distance=INI_READ_INT("Range Based Accuracy","Snap Penalty Distance",30);
	auto_penalty_distance=INI_READ_INT("Range Based Accuracy","Auto Penalty Distance",14);

	orange_cursor_limit=INI_READ_INT("Range Based Accuracy","Orange Cursor Threshold",95);
	red_cursor_limit=INI_READ_INT("Range Based Accuracy","Red Cursor Threshold",75);
}

int GetEfficiency(int xpos1,int ypos1,int xpos2,int ypos2)
{
	menu_item *mi=&WeaponMenu_Items[*WeaponMenu_ClickedItem];
	int distance=GetDistance(xpos1, ypos1, xpos2, ypos2);
	int efficiency=100;
	switch(mi->actionType)
	{
		case 5://heavy laser
		case 1://autoshot: penalty starts at 14 (7 tiles)
			if(distance>auto_penalty_distance)
			{
				efficiency-=(distance-auto_penalty_distance);
			}
			break;
		case 2://snapshot: penalty starts at 30 (15 tiles)
			if(distance>snap_penalty_distance)
			{
				efficiency-=(distance-snap_penalty_distance);
			}
			break;
		case 3://aimedshot: no distance penalty
		default:
			break;
	}

	if(efficiency<minimum_efficiency)
		efficiency=minimum_efficiency;

	return efficiency;
}

extern int firing_hl;
void DrawPCKSpriteCursorHook(__int16 a, __int16 b, int c, int d)
{
	DrawPCKSprite(a,b,c,d);

	if ( firing_hl == 0 )
	{

	//		62 -> green
	//		32 -> red
	//		16 -> orange
		current_efficiency=GetEfficiency(*currentUnit_xpos,*currentUnit_ypos,*tac_currentTile_xpos+*tac_xview,*tac_currentTile_ypos+*tac_yview);

		if(draw_accuracy)
		{
			char acc[64];
			int color=62;
			menu_item *mi=&WeaponMenu_Items[*WeaponMenu_ClickedItem];

			if(current_efficiency<orange_cursor_limit)
				color=16;
			if(current_efficiency<red_cursor_limit)
				color=32;

			int accuracy=((int)mi->accuracy*current_efficiency)/100;

//			int distance=GetDistance(*currentUnit_xpos,*currentUnit_ypos,*tac_currentTile_xpos+*tac_xview,*tac_currentTile_ypos+*tac_yview);


//			sprintf(acc,"dist=%d eff=%d acc=%d%% cor=%d%% col=%d r=%d",distance,current_efficiency,(int)mi->accuracy,((int)mi->accuracy*current_efficiency)/100,color,red_cursor_limit);
			sprintf(acc,"%d%%",accuracy);
			DrawString(acc,color,*mouse_ypos-16,*mouse_xpos-16,1);

			draw_accuracy=0;
		}
	}
}

__declspec(naked) void DrawAccuracy(void)
{
	__asm
	{
		mov draw_accuracy,1
		mov dx, word ptr ds:[0x4783A8]
		ret
	}
}

void RangeBasedAccuracy()
{
	__asm pusha

	short x1=*(short *)0x4783F8;
	short y1=*(short *)0x4783FA;
	short x2=*(short *)0x478400;
	short y2=*(short *)0x478402;
	short saved_accuracy=*accuracy;

	if( x1 == x2 && y1 == y2 ) //vertical shot
		return;

	*accuracy=(*accuracy*current_efficiency)/100;

	AdjustShotWithAccuracy();

	*accuracy=saved_accuracy;

	__asm popa
}
void ReactionFireAccuracy()
{
	__asm pusha

	int distance=GetDistance(*(short *)0x4783F8,*(short *)0x4783FA,*(short *)0x478400,*(short *)0x478402);
	int efficiency=100;

	//snapshot: penalty starts at 30 (15 tiles)
	if(distance>snap_penalty_distance)
	{
		efficiency-=(distance-snap_penalty_distance);
	}
	if(efficiency<minimum_efficiency)
		efficiency=minimum_efficiency;

	current_efficiency=efficiency;

	RangeBasedAccuracy();

	__asm popa
}

void ForceLanguage()
{
#ifdef NDEBUG
	short lang=INI_READ_INT("Mod","Force Language",0);
#else
	short lang=1;
#endif
	if(lang>0 && lang<4)
	{
		*language=lang-1;
	}
	else
	{
		//select language
		((void (*)())(0x44C650))();
	}
}

void CreateInitialAlienBases(__int16 isInitialBase)
{
	CreateXComBase(1);
	int nBases=INI_READ_INT("Mod","Initial Alien Bases",0);
	for(int i=0;i<nBases;i++)
	{
		unsigned char race=GetRandom_0_n(4);
		unsigned char zone=GetRandom_0_n(11);
		CreateAlienBase(zone,race);
	}
}


void SwitchSoldiers(unsigned char *a, unsigned char *b)
{
	//size of SOLDIER.DAT entry = 68
	unsigned char tmp[68];
	memcpy(tmp,a,68);
	memcpy(a,b,68);
	memcpy(b,tmp,68);
}

void CrewDlgAddUpDownButton(const char *str, int color, __int16 ypos, __int16 xpos, int smallFont)
{
	DrawString(str, color, ypos, xpos, smallFont);

	AddDialogButton(0xC4+8, 2);
	AddDialogButton(0xD0+8, 3);
}

int GetItemEntryFromId(int id)
{
	for(int i=0;i<*DlgNumItems;i++)
	{
		if(DlgItemIdList[i]==id)
			return i;
	}
	return -1;
}

void CrewHook()
{
	int now = timeGetTime();
	int moveOnTop = 0;

	WaitTillMouseButtonsAreReleased();

	if(timeGetTime()-now>200)
		moveOnTop=1;

	if(*DlgDialog_ClickedItem==0xffff)
		return;

	unsigned char *currentSoldier=*pSoldierDat+68**DlgDialog_ClickedItem;

	if(*mouse_xpos<128)
	{
		unsigned short baseIdx = *(unsigned short *)(currentSoldier+2);
		ShowSoldierStat(*DlgDialog_ClickedItem, baseIdx);
		*DlgDialog_ClickedItem=0xffff;
		return;
	}

	if(*DlgUpperLowerButtonPressed)
	{
		int entry=GetItemEntryFromId(*DlgDialog_ClickedItem);

		if(*DlgUpperLowerButtonPressed==4) //down
		{
			if(entry<*DlgNumItems-1)
			{
				if(moveOnTop)
				{
					while(entry<*DlgNumItems-1)
					{
						unsigned char *current = *pSoldierDat+68*DlgItemIdList[entry];
						unsigned char *next = *pSoldierDat+68*DlgItemIdList[entry+1];
						SwitchSoldiers(current, next);
						entry++;
					}
				}
				else
				{
					unsigned char *nextSoldier=*pSoldierDat+68*DlgItemIdList[entry+1];
					SwitchSoldiers(currentSoldier,nextSoldier);
				}
			}
		}
		else if(*DlgUpperLowerButtonPressed==3) //up
		{
			if(entry>0)
			{
				if(moveOnTop)
				{
					while(entry>0)
					{
						unsigned char *current = *pSoldierDat+68*DlgItemIdList[entry];
						unsigned char *previous = *pSoldierDat+68*DlgItemIdList[entry-1];
						SwitchSoldiers(current, previous);
						entry--;
					}
				}
				else
				{
					unsigned char *previousSoldier=*pSoldierDat+68*DlgItemIdList[entry-1];
					SwitchSoldiers(currentSoldier,previousSoldier);
				}
			}
		}

		*DlgDialog_ClickedItem=0xffff;
	}
}


int CheckMindControl(int y, int x, int z)
{
	if(CheckIfClickedOnUnit(y,x,z))
	{
		SetFiringPointOrigin(*currentUnit_pUnitPos);
		if(CheckHasLineOfFire(y,x,z))
		{
			return 1;
		}
		*Tactical_StatusErrorMessage=7;//no line of fire
	}
	return 0;
}

/*
 * Apply patches according to the ini file
 */

extern void FixIntroSounds();

int HasSoldierFought(__int16 soldierIdx)
{
	unsigned char *unitpos=(unsigned char *)0x4A2C40;

	for(int i=0;i<80;i++,unitpos+=14)
	{
		if(unitpos[0]==0xff)
			continue;
//		unitref_dat *unitref=*(unitref_dat **)&unitpos[4];
		unitref_dat *unitref=&((*file_missdat_uniref_dat)[i]);
		if(unitref->soldier_index==soldierIdx)
			return 1;
	}
	return 0;
}

int GetScoreForPromotion(__int16 soldierIdx)
{
	int score=0xffffffff;
	if(HasSoldierFought(soldierIdx))
		score=GetSoldierScoreForPromotion(soldierIdx);

	return score;
}

extern void ClickPauseBug();

__declspec(naked) void FixDoorJam(void)
{
//.text:0041B97B 02 DA                         add     bl, dl
//.text:0041B97D 88 58 2E                      mov     [eax+structMCDData.openedDoorTile], bl

	__asm
	{
		add     bl, dl
		mov     [eax+46], bl

		cmp [eax+0x1E],1 //sliding door
		jnz skip
		push ebx
		push esi 

		and ebx,0xff

		mov esi, ebx
		shl esi, 5
		sub esi, ebx
		shl esi, 1

		mov byte ptr [esi+0x4A924F],1 //mcd "keycode"

		pop esi
		pop ebx
skip:
		ret
	}
}

__declspec(naked) void DisableSoldierPurchase(void)
{
	__asm
	{
		mov ecx, 0x470762+0x14
		mov eax,1
		ret
	}
}

__declspec(naked) void FixScientistsEngineersOverflow(void)
{
	__asm
	{
		mov     dl, [ecx]
		add     dl, al
		jnc     nooverflow
		mov     dl, 255
nooverflow:
		mov     [ecx], dl
		ret
	}
}

//.text:00448E22 A1 6C 3F 4A 00                mov     eax, carretPosition
//.text:00448E27 8B 4F 0A                      mov     ecx, [edi+0Ah]

__declspec(naked) void IncomeOnlyItemPrice(void)
{
	__asm
	{
		mov eax, 0x4A3F6C
		mov eax, [eax]
		mov ecx, [edi+0xA]
		cmp byte ptr [edi+18],1
		jz purchaseable
		xor ecx,ecx
purchaseable:
		ret
	}
}

//.text:004489AE 8B 90 5A 07 47 00             mov     edx, [eax+47075Ah] //sell price (+8 for purchaseable)

__declspec(naked) void IncomeOnlyItemPrice2(void)
{
	__asm
	{
		mov dl, [eax+0x47075A+8] //purchaseability
		cmp dl, 1
		mov edx, [eax+0x47075A] //sell price
		jz purchaseable
		xor edx,edx
purchaseable:
		ret
	}
}

//.text:0044892B 8B 96 5A 07 47 00             mov     edx, purchaseInfo.sellPrice[esi]
__declspec(naked) void IncomeOnlyItemPrice3(void)
{
	__asm
	{
		mov dl, [esi+0x47075A+8] //purchaseability
		cmp dl, 1
		mov edx, [esi+0x47075A] //sell price
		jz purchaseable
		xor edx,edx
purchaseable:
		ret
	}
}
/*
unsigned char *fogMap=NULL;

void Fog(short a, short b, unsigned int c, unsigned int d)
{
	((void (*)(int,int,int,int))(0x430950))(a,b,c,d);

	if(!fogMap)
		return;

	unsigned char *pSeeMapCurrentTile=*(unsigned char **)0x49DB08;

	int offset=pSeeMapCurrentTile-*pSeeMap;
	unsigned char *pFogMap=fogMap+offset;

	FILE *log=fopen("C:/log.txt","a+");
//	if(*pSeeMapCurrentTile!=0&&*pSeeMapCurrentTile!=7)
//	fprintf(log,"0x%08x 0x%08x\n",pSeeMapCurrentTile,*pSeeMapCurrentTile);
	char *buf=*BackBuffer+a+320*b;

	if(*pFogMap!=*pSeeMapCurrentTile)
	{
		//fprintf(log,"0x%08x 0x%08x\n",a,b);
		//*pSeeMapCurrentTile&=~1;
		for(int i=0;i<32;i++)
		{
			if(i+a>=320)
				continue;
			if(i+a<0)
				continue;

			for(int j=0;j<40;j++)
			{
				if(j+b>=*(int *)0x4A2848)
					continue;
				if(j+b+40<*(int *)0x4A2826)
					continue;
				
				int offset=i+a+(j+b)*320;
				if(offset>=0&&offset<64000)
					if((i+j)&1)
						*(buf+i+j*320)=0;
			}
		}
	}
	fclose(log);
}

void UpdateFogMap()
{
	int size=*map_numTilesPerLevel**tac_mapZSize;
	fogMap=(unsigned char *)realloc(fogMap,size);

	for(int i=0;i<size;i++)
	{
		fogMap[i]=(*pSeeMap)[i]|0x10;
	}
}

void ClearSeeMap()
{
	int size=*map_numTilesPerLevel**tac_mapZSize;
if(fogMap)
	for(int i=0;i<size;i++)
	{
		(*pSeeMap)[i]=0;
	}
}

void UpdateSeeMap()
{
	int size=*map_numTilesPerLevel**tac_mapZSize;
if(fogMap)
	for(int i=0;i<size;i++)
	{
		if((*pSeeMap)[i]!=0)
		{
			fogMap[i]=(*pSeeMap)[i];
		}
		else
		{
			(*pSeeMap)[i]=fogMap[i]&0x7;
		}
	}
}

//.text:0042DD87 E8 44 00 00 00                call    UpdateSeeMap
void HookSeeMap(int xpos, int ypos, __int16 zpos, int facing, int distance)
{
	ClearSeeMap();
	((void (*)(int,int,__int16,int,int))(0x42DDD0))(xpos,ypos,zpos,facing,distance);
	UpdateSeeMap();
}




//.text:0042A703 38 1D D8 B6 46 00             cmp     byte_46B6D8, bl
__declspec(naked) void FixSeeMap(void)
{
	__asm
	{
		pusha
		call UpdateSeeMap
		popa
		mov ebx, 0x46B6D8
		cmp[ebx],0
		mov ebx,0
		ret
	}
}
*/
void CreateCraftDeequipButton(int ypos, int xpos, int height, int width, int color, char *str)
{
//		int __cdecl CreateButton(int ypos, int xpos, int height, int width, int color, char *str)
	CreateButton(ypos, xpos-8, height, width, color, str);
	CreateButton(*(short *)0x49B952+*(short *)0x49A83E,*(short *)0x49B90E+0x28+0x46+8,0x10,0x46,*(char *)0x49AA5E,"DE-EQUIP");
}

__declspec(naked) void ExitCraftArmament(void)
{
	__asm
	{
//		 .data:0049B860 ?? ??                         DlgClickedButton dw ?                   ; DATA XREF: BuildFacilities+5Dr

		push esi
		mov esi, 0x49B860 //Clicked button
		cmp word ptr [esi], 1
		pop esi
		jz short cancel

		push edi
		mov edi,[esp+12]
		mov eax,0x4569E5
		jmp eax
cancel:
		pop esi
		ret
	}
}

#define DOOR_COST 4

void TryToOpenDoor(int pUnitPos, int orientation)
{
	short oldFacing_y;
	short oldFacing_x;

	UpdateCurrentlyFacedTile();
	oldFacing_y=*facingTile_ypos;
	oldFacing_x=*facingTile_xpos;

	TryChangeUnitOrientation(pUnitPos, orientation);

	UpdateCurrentlyFacedTile();


	if((*currentUnit_pUnitRef)->TUs_Current>=DOOR_COST) {
		if(*facingTile_isValid&&oldFacing_y==*facingTile_ypos&&oldFacing_x==*facingTile_xpos)
		{
			sub_422B60(*currentUnit_ypos,*currentUnit_xpos,*currentUnit_zpos,*facingTile_ypos,*facingTile_xpos,orientation, (*currentUnit_pUnitRef)->MovementType);
			if(*MustGoThroughDoor)//MustGoThroughDoor
			{
				char unitref[124];
				*(short *)(0x47841A)=*facingTile_ypos;
				*(short *)(0x47841C)=*facingTile_xpos;

				//OpenFacingDoor messes with unitref data so we just back it up
				memcpy(unitref,*currentUnit_pUnitRef,124);
				OpenFacingDoor(*MustGoThroughDoor);
				memcpy(*currentUnit_pUnitRef,unitref,124);

				UpdateSeeMapAndVisibleEnemies();

				(*currentUnit_pUnitRef)->TUs_Current-=DOOR_COST;
			}
		}
	}
	else
	{
		//Not enough TUs
		*Tactical_StatusErrorMessage=1;
	}
}


/*
.text:00418780                               ; int __cdecl TacticalComputeSoldiersLightSources()
.text:00425940                               ; int __cdecl TacticalDrawMap_sub_425940()
.text:0042EA40                               ; int __cdecl ComputeVisibleAliens(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance)
.text:00420D61 E8 DA DC 00 00                call    ComputeVisibleAliens
*/
void UpdateTerrain(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance)
{
	ComputeVisibleAliens(xpos, ypos, zpos, orientation, distance);
	TacticalComputeSoldiersLightSources();
	UpdateSeeMapAndVisibleEnemies();
	((void (*)())0x425940)();
/*
	mov     eax, BackBuffer
lea     ecx, [eax+0B400h]
push    ecx
push    eax
push    1
call    _sub_4302A0
*/
	((void (*)(int,char *,char *))0x4302A0)(1,*BackBuffer+0xB400,*BackBuffer);
}


/*
.text:00434D47 8A 04 0A                      mov     al, [edx+ecx]
.text:00434D4A 84 C0                         test    al, al
*/
__declspec(naked) int AssignAllScientists()
{
	//ebp = available scientist
	//ebx = available lab space
	//[edx+ecx] = assigned scientists
	__asm
	{
		mov al,[edx+ecx]
		test al,al
		jz assign_all
		ret
assign_all:
		mov [esp+24],1
		cmp ebx, ebp
		jl lab_space_full
//enough space for everyone
		mov eax, ebp
		mov [edx+ecx], al
		sub ebx, ebp
		xor ebp,ebp
		test ebp,ebp
		ret

lab_space_full:
		mov [edx+ecx], bl
		sub ebp,ebx
		xor ebx,ebx
		test ebx,ebx
		ret
	}
}

//.text:00436311 66 8B 84 71 8C 00 00 00       mov     ax, [ecx+esi*2+8Ch]
//.text:00436319 66 3B C2                      cmp     ax, dx

__declspec(naked) int AssignAllEngineers()
{
	// [esp+60] -> n available engineer
	// [esp+64] -> n available build space
	// [ecx+esi*2+8Ch] -> assigned engineers
	// edx -> 0
	__asm
	{
		mov     ax, [ecx+esi*2+0x8C]
		cmp     ax, dx
		jz assign_all
		ret
assign_all:
		mov [esp+32],1
		mov ebp,1
		mov ax, [esp+60]
		cmp ax, [esp+64]
		ja workspace_full
		mov [ecx+esi*2+8Ch],ax
		sub [esp+64],ax
		mov [esp+60],dx
		cmp eax,eax
		ret


workspace_full:
		mov ax, [esp+64]
		mov [ecx+esi*2+8Ch],ax
		mov [esp+64],dx
		sub [esp+60],ax
		cmp eax,eax
		ret
	}
}

void SaveEquipment();
void EnableObDataPatching();

__declspec(naked) void CheckMainState()
{
	__asm
	{
		//cmp isDuringReactionFire, 0
		mov ecx, 0x4783E4
		cmp byte ptr [ecx], 0
			
		jnz end
		mov ecx, 0x4781DC
		cmp word ptr [ecx], 0
end:
		ret
	}
}

__int64 freq = -1;

void DrawFPSGeo()
{
	static __int64 last, now;
	static int frames;
	static int fps;
	frames++;

	if(freq == -1)
	{
		QueryPerformanceFrequency((LARGE_INTEGER *)&freq);
		QueryPerformanceCounter((LARGE_INTEGER *)&last);
		return;
	}
	
	QueryPerformanceCounter((LARGE_INTEGER *)&now);

	double time=(double)(now-last)/(double)(freq);
	if(time>=1.0)
	{
		fps = frames;
		frames = 0;
		last = now;
	}

	DrawNumber2(fps, 0xf5, 1, 1, 1);
}

/*
 * Get the true owner of a unit after it got memory controlled
 * esi : pUnitRef
 * dl  : return value
 */
__declspec(naked) void GetOwner()
{
/*
  0: X-Com
  1: Alien
  2: Civilian
*/
	__asm
	{
		mov dl, [esi] //type of unit
		cmp dl, 3
		jle xcom
		cmp dl, 15
		je civ
		cmp dl, 16
		je civ

		mov dl, 1
		ret

	civ:
		mov dl, 2
		ret

	xcom:
		mov dl, 0
		ret
	}
}

__declspec(naked) void WoundCheck()
{
/*
3: Tank                                            
11: Chryssalid                                     
13: Sectopod
14: Cyberdisc                                      
17: Zombie        
*/
	__asm
	{
		mov ecx,[eax+4] //unitref
		mov cl, [ecx]   //unit type
		cmp cl, 3
		jz no_wound
		cmp cl, 11
		jz no_wound
		cmp cl, 13
		jz no_wound
		cmp cl, 14
		jz no_wound
		cmp cl, 17
		jz no_wound

		xor ecx,ecx
		ret
	no_wound:
		xor ecx,ecx
		inc ecx
		ret
	}
}

void MyTacticalDrawPanicMessage(int unitIdx)
{
	if(*(short *)0x478418 == 0)
		TacticalDrawPanicMessage(unitIdx);
}

void MyTactivalViewPosPanic(int ypos, int xpos, __int16 zpos)
{
	if(*(short *)0x478418 == 0)
		SetTacticalViewPos(ypos, xpos, zpos);
}

char ShowCraftReadyBox_title[64];
char ShowCraftReadyBox_info[64];
void ShowCraftReadyBox_Strings()
{
	static int init = 0;

	if(init == 1)
		return;

	INI_READ_STRING("Craft Ready Message","Title","Aircraft ready",ShowCraftReadyBox_title,63);
	INI_READ_STRING("Craft Ready Message","Info","A craft has been refitted",ShowCraftReadyBox_info,63);

	init = 1;
}

void ShowCraftReadyBox_Impl(unsigned char *pCraft)
{
	char craftName[64]="Unknown craft";
	const char *craftType=StringTable_geoscape[0x239+pCraft[0]];
	unsigned char baseLoc = pCraft[26];
	unsigned char baseIdx=(*locationList+20*baseLoc)[1];
	char *baseName=(char *)&(*pBaseList+292*baseIdx)[0];
	unsigned char craftIdx=(pCraft-*craftList)/104;

	for(unsigned char i=0;i<50;i++)
	{
		unsigned char type=(*locationList+20*i)[0];
		if(type!=2)
			continue;
		unsigned char craftRef=(*locationList+20*i)[1];
		if(craftRef==craftIdx)
		{
			unsigned short suffix=(*locationList+20*i)[0xa];
			sprintf(craftName,"%s-%d",craftType,suffix);
			break;
		}
	}

	ShowCraftReadyBox_Strings();

	(*geo_num_rearming_crafts)--;

	//Craft background
	LoadGeographBackScreen(14);
	LoadGeodataBackPalette(4);

	//Draw box
	((void (*)(int,int,int,int,int,int,int,int,int,int))(0x43D8C0))(0x5a,0x70,0x14,0x20,0x30,0x18,0x78,0xD0,0x14,0x86);

	DrawString(ShowCraftReadyBox_title,0x86,0x38,0x30,0);
	DrawString(ShowCraftReadyBox_info,0x86,0x48,0x30,1);

	DrawString(StringTable_geoscape[0x109],0x86,0x52+6,0x30,1); //CRAFT
	DrawDottedLine(0x86,0x82+6,1);
	DrawString(craftName,0x8B,0x52+6,0x82,1);

	DrawString(StringTable_geoscape[0x10B],0x86,0x5a+6,0x30,1); //BASE
	DrawDottedLine(0x86,0x82+6,1);
	DrawString(baseName,0x8B,0x5a+6,0x82,1);
/*
	DrawString(roswel_terrain,0x86,0x62,0x30,1);
	DrawDottedLine(0x86,0x82,1);
	DrawString(terrain,0x8B,0x62,0x82,1);
*/
	*ui_numButtons=0;

	//"Centre + 5sec" button
	CreateButton(0x80,0x30,0x0C,0xA0,0x86,StringTable_geoscape[48]);

	//Cancel
	CreateButton(0x90,0x30,0x0C,0xA0,0x86,StringTable_geoscape[49]);

	((void (*)(int))(0x42F680))(1);

	WaitTillMouseButtonsAreReleased();
	int button;
	while(!(button=CheckForClickedButton()));

	*ui_numButtons=0;


	if(button==1)
	{
		*geo_timeSpeed=1;
		RotateGlobeToLocation(baseLoc);
	}
}
#include "resource.h"
__declspec(naked) void ShowCraftReadyBox()
{
	__asm {
		pusha
		push esi
		call ShowCraftReadyBox_Impl
		pop esi
		popa
		ret
	}
}

ATOM __stdcall MyRegisterClassA(WNDCLASSA *lpWndClass)
{
	lpWndClass->hCursor = LoadCursor(hPatcherDLL, MAKEINTRESOURCE(IDC_EMPTY));
	lpWndClass->style = CS_HREDRAW | CS_VREDRAW;
	return RegisterClassA(lpWndClass);
}

void ClientResize(int nWidth, int nHeight);
HWND __stdcall MyCreateWindowExA(DWORD dwExStyle, LPCSTR lpClassName, LPCSTR lpWindowName, DWORD dwStyle, int X, int Y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam)
{
	char buf[128];
	int top,left,bottom,right;
	INI_READ_STRING("Mod","D3D Window Position","",buf,128);
	if(sscanf(buf,"%d %d %d %d",&top,&left,&bottom,&right) == 4)
	{
		X = left;
		Y = top;
		nWidth = right - left;
		nHeight = bottom - top;
	}

	if(!INI_READ_INT("Mod","Always On Top",0))
	{
		dwExStyle&=~WS_EX_TOPMOST;
	}

	return CreateWindowExA(dwExStyle, lpClassName, lpWindowName, WS_OVERLAPPEDWINDOW, X, Y, nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam);
//	return CreateWindowExA(dwExStyle, lpClassName, lpWindowName, dwStyle, X, Y, nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam);
}


static DWORD WINAPI AnimationsThread(LPVOID lpThreadParameter)
{
	short *locationsOffset = (short *)0x4785EC;
	short *cursorFrame = (short *)0x4783A8;
	short *smokeFrame = (short *)0x4A5FBA;
	short *xxx=(short *)0x4783A6;
	char *currentUnitArrow=(char *)0x4783AA;

	*locationsOffset = 0;
	*smokeFrame = 0;
	while(true)
	{
		*locationsOffset = *locationsOffset?0:1;
		*xxx=*locationsOffset;
		*currentUnitArrow=(char)*locationsOffset;
		if(*cursorFrame == 3)
		{
			*cursorFrame = 0;
		}
		else
		{
			(*cursorFrame)++;
		}

		*smokeFrame=*cursorFrame;
		Sleep(100);
	}
}

void FixAnimations()
{
//.text:0045769C 66 89 15 EC 85 47 00          mov     word_4785EC, dx
	Nop(0x45769C,7);
//.text:0042A881 66 89 0D A8 83 47 00          mov     word_4783A8, cx
//.text:0042A890 66 89 1D A8 83 47 00          mov     word_4783A8, bx
	Nop(0x42A881,7);
	Nop(0x42A890,7);

//.text:0042A888 66 A3 A6 83 47 00             mov     word_4783A6, ax
	Nop(0x42A888,6);

//.text:0042A8A8 66 A3 BA 5F 4A 00             mov     word_4A5FBA, ax
//.text:0042A8B0 66 89 1D BA 5F 4A 00          mov     word_4A5FBA, bx
	Nop(0x42A8A8,6);
	Nop(0x42A8B0,7);

//.text:00426880 88 0D AA 83 47 00             mov     byte_4783AA, cl
	Nop(0x426880,6);

	CreateThread(NULL,0,AnimationsThread,NULL,0,NULL);
}





void ApplyPatches()
{
	InsertCall(0x44C6E9,ShowMod);


	if(int capacity = INI_READ_INT("Mod","General Store Capacity",0))
	{
		unsigned short cap = capacity * 10;
//		.text:00439C85 66 81 C5 F4 01                add     bp, 500
		if((unsigned int)cap*35>65535)
		{
			cap = 65535/35;
		}
		PatchInPlace(0x439C85+3,&cap,2);
//.text:00439E60 0F 8D E3 00 00 00             jge     loc_439F49
		char jae[] = {0x83};
		PatchInPlace(0x439E60+1,&jae,1);
//.text:00439E9D 66 3D F4 01                   cmp     ax, 1F4h
		PatchInPlace(0x439E9D+2,&cap,2);


//.text:0045639F 7E 14                         jle     short loc_4563B5
		char jbe[] = {0x76};
		PatchInPlace(0x45639F,&jbe,1);
//.text:004366A5 7C 11                         jl      short loc_4366B8
		char jb[] = {0x72};
		PatchInPlace(0x4366A5,&jb,1);
//.text:00438BAF 7C 17                         jl      short loc_438BC8
		PatchInPlace(0x438BAF,&jb,1);


	}

	if(INI_READ_INT("Bug Fix","Animations Speed",0))
	{
		FixAnimations();
	}

	if(INI_READ_INT("Mod","D3D",0) && INI_READ_INT("Mod","D3D Windowed",0))
	{
//		.text:0045DDF2 FF 15 4C 91 46 00             call    ds:RegisterClassA
		InsertCall(0x45DDF2,MyRegisterClassA);
		Nop(0x45DDF2+5);

//		.text:0045DE27 FF 15 2C 91 46 00             call    ds:CreateWindowExA
		InsertCall(0x45DE27,MyCreateWindowExA);
		Nop(0x45DE27+5);
/*
.text:0045DE53 56                            push    esi                             ; bShow
.text:0045DE54 FF 15 44 91 46 00             call    ds:ShowCursor
.text:0045DE5A 56                            push    esi                             ; hCursor
.text:0045DE5B FF 15 40 91 46 00             call    ds:SetCursor
*/
		Nop(0x45DE53,14);
	}

//	if(INI_READ_INT("Bug Fix","Low Fuel After Mission",0))
//	{
//.text:00457D6B 0C 02                         or      al, 2
//		Nop(0x457D6B,2);
//	}

	if(INI_READ_INT("Craft Ready Message","Apply",0))
	{
//		.text:0044287F 66 FF 0D 60 AA 49 00          dec     geo_num_rearming_crafts
		InsertCall(0x44287F,ShowCraftReadyBox);
		Nop(0x44287F+5,2);
	}

	if(INI_READ_INT("Mod","No Alien Freak Out Messages",0))
	{
//.text:0041F60F E8 BC 04 00 00                call    TacticalDrawPanicMessage
//.text:0041F7A5 E8 26 03 00 00                call    TacticalDrawPanicMessage
//.text:0041F58F E8 3C 05 00 00                call    TacticalDrawPanicMessage
		InsertCall(0x41F60F,MyTacticalDrawPanicMessage);
		InsertCall(0x41F7A5,MyTacticalDrawPanicMessage);
		InsertCall(0x41F58F,MyTacticalDrawPanicMessage);

		InsertCall(0x41F6BF,MyTactivalViewPosPanic);
		InsertCall(0x41FA40,MyTactivalViewPosPanic);
		InsertCall(0x41FB9B,MyTactivalViewPosPanic);
	}

	if(INI_READ_INT("Bug Fix","Hostile Civilians",0))
	{
		//.text:00413203 84 C9                         test    cl, cl
		//.text:00413205 0F 94 C2                      setz    dl
		InsertCall(0x413203,GetOwner);
	}

	if(INI_READ_INT("Mod","Alien Bleeding",0))
	{

		//.text:0040E1AB 8A 48 09                      mov     cl, [eax+structUnitPos.owner]
		//.text:0040E1AE 84 C9                         test    cl, cl
		InsertCall(0x40E1AB, WoundCheck);

		//.text:0040E1B0 0F 85 04 01 00 00             jnz     loc_40E2BA
//		Nop(0x40E1B0,6);

		//Verbose death
		//.text:00413590 0F 85 92 00 00 00             jnz     continue
		//Nop(0x413590,6);
		//.text:0041326D 0F 85 98 00 00 00             jnz     loc_41330B
		//Nop(0x41326D,6);
	}

	if(INI_READ_INT("Mod","No Auto Wake Up",0))
	{
		//.text:00413560 E8 EB 00 00 00                call    WakeUnconsciousUnitUp
		Nop(0x413560,5);
	}

	if(INI_READ_INT("Hack","FPS",0))
	{
		InsertCall(0x44102F,DrawFPSGeo);
	}


	/*
	.text:004129FC 38 1D E4 83 47 00             cmp     isDuringReactionFire, bl        ; case 0x4
	*/
	if(0)
	{
		Nop(0x4129FC);
		InsertCall(0x4129FC + 1, CheckMainState);
	}
	//fog of war
	/*
	if(0)
	{
		//.text:0042683E E8 0D A1 00 00                call    sub_430950

		InsertCall(0x42683E,Fog);
		InsertCall(0x4269B2,Fog);
		InsertCall(0x401014,UpdateFogMap);
		InsertCall(0x42DD87,HookSeeMap);
//		InsertCall(0x42A703,FixSeeMap);
//		Nop(0x42A703+5);
	}
	*/

	//realtime terrain
	if(0)
	{
		InsertCall(0x420D61, UpdateTerrain);
	}

	if(INI_READ_INT("OBDATA.DAT","Apply",0))
	{
		EnableObDataPatching();
	}

	if(INI_READ_INT("Mod","Assign All Personnel",0))
	{
//		.text:00434D47 8A 04 0A                      mov     al, [edx+ecx]
//		.text:00434D4A 84 C0                         test    al, al
		InsertCall(0x434D47,AssignAllScientists);

//.text:00436311 66 8B 84 71 8C 00 00 00       mov     ax, [ecx+esi*2+8Ch]
//.text:00436319 66 3B C2                      cmp     ax, dx

		InsertCall(0x436311,AssignAllEngineers);
		Nop(0x436311+5,6);

	}

	//Funky fire
	if(INI_READ_INT("Bug Fix","Funky Fire",0))
	{
		/*
		.text:0040D51C E8 7F C7 01 00                call    ApplyFireAndStunDamage
		.text:0040F092 E8 09 AC 01 00                call    ApplyFireAndStunDamage
		.text:0041074E E8 4D 95 01 00                call    ApplyFireAndStunDamage
		.text:00410ADB E8 C0 91 01 00                call    ApplyFireAndStunDamage
		*/
		Nop(0x40D51C,5);
		Nop(0x40F092,5);
		Nop(0x41074E,5);
		Nop(0x410ADB,5);
		char fireDamage[]={10};
//		.text:00429CD8 6A 05                         push    5                               ; rndMax
		PatchInPlace(0x429CD8+1,fireDamage,1);
	}

	//Open doors  la TFTD
	if(INI_READ_INT("Mod","TFTD Doors",0))
	{
		InsertCall(0x42010B,TryToOpenDoor);
	}

	if(INI_READ_INT("Mod","De-equip Crafts",0))
	{
		char cancelButtonWidth[]={0x46};
		PatchInPlace(0x456D5E+1,cancelButtonWidth,1);
		InsertCall(0x456D6B,CreateCraftDeequipButton);
//		.text:004569C1 0F 84 7F 01 00 00             jz      exit
		InsertJnz(0x4569C1,ExitCraftArmament);
	}

	if(INI_READ_INT("Mod","Funding Council Income Only",0))
	{
//.text:00448E22 A1 6C 3F 4A 00                mov     eax, carretPosition
//.text:00448E27 8B 4F 0A                      mov     ecx, [edi+0Ah]
		InsertCall(0x448E22,IncomeOnlyItemPrice);
		Nop(0x448E27,3);
		InsertCall(0x4489AE,IncomeOnlyItemPrice2);
		Nop(0x4489AE+5);
		InsertCall(0x44892B,IncomeOnlyItemPrice3);
		Nop(0x44892B+5);
		
		
/*		
		//		.text:00448E27 8B 4F 0A                      mov     ecx, [edi+0Ah]
		char patch[]={0x33, 0xC9, 0x90};
		PatchInPlace(0x448E27,patch,3);

//.text:004489B4 29 15 38 A8 49 00             sub     dword_49A838, edx
		Nop(0x4489B4,6);
//.text:00448931 03 C2                         add     eax, edx
		Nop(0x448931,2);
*/
	}

	if(INI_READ_INT("Bug Fix","Personnel Overflow",0))
	{
		InsertCall(0x4415E3,FixScientistsEngineersOverflow);
		Nop(0x4415E3+5);
		InsertCall(0x44160C,FixScientistsEngineersOverflow);
		Nop(0x44160C+5);
	}


	if(INI_READ_INT("Mod","Limited Military",0))
	{
//		.text:0043B133 BE 08 00 00 00                mov     esi, 8
		unsigned char numSoldiers=INI_READ_INT("Mod","Limited Military",0);
		PatchInPlace(0x43B134,&numSoldiers,1);

//		.text:00436CE8 B9 62 07 47 00                mov     ecx, offset purchaseInfo.canBeBought
		InsertCall(0x436CE8,DisableSoldierPurchase);

//Reduce wage
//		.text:0043BFD7 C1 E0 05                      shl     eax, 5
		unsigned char shift[]={2};
		PatchInPlace(0x43BFD7+2,shift,1);
	}

	if(INI_READ_INT("Bug Fix","Door Jam",0))
	{
		InsertCall(0x41B97B,FixDoorJam);
	}

	if(INI_READ_INT("Mod","No Funkers",0))
	{
		/*
		.text:00449262 E8 99 02 00 00                call    GetSoldierScoreForPromotion
		.text:0044930B E8 F0 01 00 00                call    GetSoldierScoreForPromotion
		.text:004493BF E8 3C 01 00 00                call    GetSoldierScoreForPromotion
		.text:00449473 E8 88 00 00 00                call    GetSoldierScoreForPromotion
		*/
		InsertCall(0x449262,GetScoreForPromotion);
		InsertCall(0x44930B,GetScoreForPromotion);
		InsertCall(0x4493BF,GetScoreForPromotion);
		InsertCall(0x449473,GetScoreForPromotion);

	}

	if(INI_READ_INT("Mod","Bloodthirst",0))
	{
		//	0f b7 c2	 movzx	 eax, dx
		char patch[]={0x0f,0xb7,0xc2};
		PatchInPlace(0x4495BD,patch,3);
		Nop(0x4495BD+3,7);
	}

	extern void Shortcuts();

	//shortcuts
	if(INI_READ_INT("Battlescape Shortcuts","Apply",0) || INI_READ_INT("Geoscape Shortcuts","Apply",0) || (INI_READ_INT("Mod","D3D",0) && INI_READ_INT("Mod","D3D Windowed",0)))
	{
		Shortcuts();
	}


	if(INI_READ_INT("Caps","Apply",0))
	{
		char jae[] = {0x73};

		//.text:0044741D B8 50 00 00 00                mov     eax, 80                         ; TUs cap
		unsigned char TU=INI_READ_INT("Caps","Time Units",80);
		PatchInPlace(0x44741D+1,&TU,1);

		//.text:0044745C B8 3C 00 00 00                mov     eax, 60                         ; Health cap
		unsigned char health=INI_READ_INT("Caps","Health",60);
		PatchInPlace(0x44745C+1,&health,1);

		//.text:0044749B B8 46 00 00 00                mov     eax, 70                         ; Strength cap
		unsigned char strength=INI_READ_INT("Caps","Strength",70);
		PatchInPlace(0x44749B+1,&strength,1);

		//.text:004474DA B8 64 00 00 00                mov     eax, 100                        ; Energy cap
		unsigned char energy=INI_READ_INT("Caps","Energy",100);
		PatchInPlace(0x4474DA+1,&energy,1);

		//.text:0044751D 83 FA 64                      cmp     edx, 100                        ; Reactions cap
		unsigned char reactions=INI_READ_INT("Caps","Reactions",100);
		PatchInPlace(0x44751D+2,&reactions,1);
		//.text:00447520 7D 44                         jge     short loc_447566
		PatchInPlace(0x447520,jae,1);

		//.text:00447572 83 FA 78                      cmp     edx, 120                        ; Firing accuracy cap
		unsigned char fa=INI_READ_INT("Caps","Firing Accuracy",120);
		PatchInPlace(0x447572+2,&fa,1);
		//.text:00447575 7D 44                         jge     short loc_4475BB
		PatchInPlace(0x447575,jae,1);

		//.text:004475C7 83 FA 78                      cmp     edx, 120                        ; Melee accuracy cap
		unsigned char ma=INI_READ_INT("Caps","Melee Accuracy",120);
		PatchInPlace(0x4475C7+2,&ma,1);
		//.text:004475CA 7D 44                         jge     short loc_447610
		PatchInPlace(0x4475CA,jae,1);

		//.text:0044761C 83 FA 78                      cmp     edx, 120                        ; Throwing accuracy cap
		unsigned char ta=INI_READ_INT("Caps","Throwing Accuracy",120);
		PatchInPlace(0x44761C+2,&ta,1);
		//.text:0044761F 7D 44                         jge     short loc_447665                ; psi skill
		PatchInPlace(0x44761F,jae,1);

		//.text:00447665 80 7E 33 64                   cmp     byte ptr [esi+33h], 100         ; psi skill cap
		unsigned char ps=INI_READ_INT("Caps","Psi Skill",100);
		PatchInPlace(0x447665+3,&ps,1);
	}

	if(INI_READ_INT("Initial Base","Apply",0))
	{
		SafeBaseDesign();
	}

	if(INI_READ_INT("Line Of Fire Check","Mind Control",0))
	{
		//.text:0041EE52 E8 99 13 00 00                call    CheckIfClickedOnUnit
		InsertCall(0x41EE52,CheckMindControl);
	}
	if(INI_READ_INT("Line Of Fire Check","Panic",0))
	{
//		.text:0041F132 E8 B9 10 00 00                call    CheckIfClickedOnUnit
		InsertCall(0x41F132,CheckMindControl);
	}
	if(INI_READ_INT("Line Of Fire Check","Mind Probe",0))
	{
//		.text:0041FD50 E8 9B 04 00 00                call    CheckIfClickedOnUnit
		InsertCall(0x41FD50,CheckMindControl);
	}

	if(INI_READ_INT("Bug Fix","Intro Sounds",0))
	{
		FixIntroSounds();
	}	
/*
	//force retaliation
	{
		char patch[]={0x90,0x90,0x90,0x90,0x90,0x90};
		PatchInPlace(0x432AD8,patch,6);
		PatchInPlace(0x432B06,patch,2);
		PatchInPlace(0x4594BD,patch,6);
	}
//*/

	//move soldiers in ship
	if(INI_READ_INT("Mod","Reorder Soldiers In Crafts",0))
	{
		//.text:00455EFD E8 9E A2 FF FF                call    DrawString
		InsertCall(0x455EC7,CrewDlgAddUpDownButton);

//		.text:00455CEE E8 AD 7B FE FF                call    WaitTillMouseButtonsAreReleased
		InsertCall(0x455CEE,CrewHook);
	}

	//Stun
	if(INI_READ_INT("Mod","Stun Fest",0))
	{
		extern int stunActivated;
		stunActivated=1;

		if(!INI_READ_INT("Mod","Heavy Laser",0))
		{
			ModStun();
		}
	}
	//Heavy laser MUST be after stun fest or combination won't work
	if(INI_READ_INT("Mod","Heavy Laser",0))
	{
		ModHeavyLaser();
	}

	int fast=INI_READ_INT("Mod","Fast Base Defenses",0);
	if(fast)
	{
		Nop(0x4484C9,5);
		Nop(0x4484ED,5);
		Nop(0x44852E,5);
		Nop(0x4485F0,5);
		Nop(0x448629,5);
		Nop(0x448674,5);
		Nop(0x4486CE,5);
		Nop(0x448773,5);
		Nop(0x448788,5);
		Nop(0x4487A8,5);

		if(fast==2) //remove the button press
		{
			Nop(0x4487E0,2);
		}
	}


	//Create some bases from the begining
	if(INI_READ_INT("Mod","Initial Alien Bases",0))
	{
		//.text:004513A8 call    CreateXComBase
		InsertCall(0x4513A8,CreateInitialAlienBases);
	}

	if(INI_READ_INT("Mod","Disable Base Defenses",0))
	{
		//.text:004578FC E8 8F 0A FF FF                call    ActivateBaseDefensesAgainstAlienShip
		char patch[]={0x33,0xC0,0x90,0x90,0x90}; //xor eax,eax
		PatchInPlace(0x4578FC,patch,5);
	}

	if(INI_READ_INT("Mod","Surrender Defence Missions",0))
	{
//		.text:00457913 E8 A8 2D 00 00                call    AreThereSoldiersInBase
		char patch[]={0x33,0xC0}; //xor eax,eax
		PatchInPlace(0x457913,patch,2);
		Nop(0x457913+2,3);
	}

	if(INI_READ_INT("Range Based Accuracy","Apply",0))
	{
		InsertCall(0x42669F,DrawAccuracy);
		Nop(0x42669F+5,2);

		InsertCall(0x4266D6,DrawPCKSpriteCursorHook);
		
		//aimed/snap shot
		InsertCall(0x40D369,RangeBasedAccuracy);

		//autoshot
		InsertCall(0x40EDFB,RangeBasedAccuracy);

		//reaction fire
		InsertCall(0x4105A4,ReactionFireAccuracy);

		LoadAccuracyParameters();
	}

	if(INI_READ_INT("Mod","More Smoke",0))
	{
		ModMoreSmoke();
	}

	//base maintenace estimate
	if(INI_READ_INT("Bug Fix","Displayed Base Maintenance Cost",0))
	{
		char patch[]={
			0x03, 0xc0,			// add eax,eax
			0x8a, 0x04, 0xc1,	// mov al, BYTE PTR [ecx+eax*8]
			0x0f, 0xb6, 0xc0,	// movzx	 eax, al
			0x90, 0x90, 0x90, 0x90, 0x90 //nops
		};
		PatchInPlace(0x440651,patch,13);
		Nop(0x44066E,3);
	}

	//Base build stacking
	if(INI_READ_INT("Mod","Base Building Stacking",0))
	{
		ModBaseBuildingStacking();
	}

	//Roswell mod. Scout ships can crash randomly
	if(INI_READ_INT("Roswell","Apply",0))
	{
		ModRoswell();
	}
	
	if(INI_READ_INT("Mod","Keep Base Navigation Modules",0))
	{
		Nop(0x415066,9);
	}

	//crafts always ready
	if(INI_READ_INT("Mod","Crafts Always Ready",0))
	{
		//Check fuel level instead of state
		char patch[]={0x18,0x03,0x7c};
		PatchInPlace(0x45174E+4,patch,3);
	}

	if(INI_READ_INT("Mod","Stunned units KIA",0))
	{
		//Keep cursor enabled during alien turn to be able to click the dialog box
		Nop(0x401019,5);
		//Keep cursor while moving in case proxmine kills a body
		Nop(0x420370,5);

		InsertCall(0x40CEB3,CheckDestroyObject);
	}

#ifdef NDEBUG
	if(INI_READ_INT("Mod","D3D",0) || INI_READ_INT("Mod","HQ4x",0) || INI_READ_INT("Bug Fix","Video Pitch",0))
#endif
	{
#ifdef NDEBUG
		if(INI_READ_INT("Mod","D3D",0))
		{
			if(INI_READ_INT("Mod","HQ4x",0))
				SetScalingMethod(4);
			else
				SetScalingMethod(3);
		}
		else if(INI_READ_INT("Mod","HQ4x",0))
			SetScalingMethod(2);
		else if(INI_READ_INT("Bug Fix","Video Pitch",0))
			SetScalingMethod(1);
#else
		SetScalingMethod(3);
#endif
	}
	
	if(INI_READ_INT("Mod","No Blaster Bomb Drift",0))
	{
		Nop(0x426E78,5);
		Nop(0x40595F,5);
	}
	else if(INI_READ_INT("Bug Fix","Collectors Edition Blaster Bomb Bug",0))
	{
		InsertCall(0x426E78,FixedAccuracyCompensation);
		InsertCall(0x40595F,FixedAccuracyCompensation);
	}

	if(INI_READ_INT("Mod","More Reaction Fire",0))
	{
		InsertCall(0x42192B,ReactionFire1);
		InsertCall(0x421921,ReactionFire2);
	}

	if(INI_READ_INT("Mod","Manual Interception Fire Mode",0))
	{
		Nop(0x446B61,2);
		Nop(0x446AE8,6);

	//disable damage
	//	PatchInPlace(0x446E48,patch,4);
		
	}

#ifdef NDEBUG
	if(INI_READ_INT("Mod","Skip Intro",0))
#endif
	{
		Nop(0x45E69F,5);
	}

#ifdef NDEBUG
	if(INI_READ_INT("Equipment Screen","Show Stats",0)) 
#endif
	{
		//Patch coordinates of "TUs>" string
		char patchy[]={ 0x18+8 };
		char patchx[]={ 0xFA-5 };
		PatchInPlace(0x418E9E,patchy,1);
		PatchInPlace(0x418E99,patchx,1);
		InsertJmp(0x419482,ShowEncumberance);
	}


#ifdef EQUIPMENT
	void SaveEquipment();
	void InitNewGeoGameHook();
	void SaveTacticalGameHook(char *slot);
	void SaveGeoGameHook(char *slot);
	void LoadGameHook(char *slot);
	extern int auto_flares;

	if(INI_READ_INT("Equipment Screen","Save Equipment",0))
	{
		//.text:00418C61 E8 5A 16 00 00                call    Tactical_EquipTeamDisplay
		InsertCall(0x418C61,SaveEquipment);
//.text:0044A166 E8 D5 0A FF FF          call    InitNewGeoGame
		InsertCall(0x44A166,InitNewGeoGameHook);

//.text:00415B89 E8 92 04 00 00          call    SaveTacticalData
		InsertCall(0x415B89,SaveTacticalGameHook);

//.text:0044A7EC E8 CF 03 00 00          call    SaveGeoGameData
		InsertCall(0x44A7EC,SaveGeoGameHook);

//.text:0044A59A E8 11 14 00 00          call    LoadGeographGame
		InsertCall(0x44A59A,LoadGameHook);

		if(INI_READ_INT("Equipment Screen","Auto Flares",0))
			auto_flares = 1;

	}
#endif


	if(INI_READ_INT("Equipment Screen","Show Grenade State",0))
	{
		//.text:00418FEB 8B 14 8D 60 D6 49 00          mov     edx, StringsTable2_tactical[ecx*4]
		InsertCall(0x418FEB,GrenadeState);
		Nop(0x418FEB+5,2);
	}

	if(INI_READ_INT("Music","Apply",0)) 
	{
		ModMusic();
	}
	//CD/mp3 music do not have the freeze bug. The 2 patches would not work together anyway...
	else
#ifdef NDEBUG
	if(INI_READ_INT("Bug Fix","Music Change Freeze",0))
#endif
	{
		ClickPauseBug();
	}

	if(INI_READ_INT("Wreck Analysis","Apply",0))
	{
		InsertCall(0x4482B0,WreckAnalysis);
	}

/////////////////Bug Fixes/////////////////////

	//elerium ships
	if(INI_READ_INT("Bug Fix","Elerium-fueled Craft Bug",0))
	{
		InsertCall(0x4421AC,EleriumShipFix);
	}

	//Force the fix if using Crafts always ready to prevent transfered crafts from being stuck
	if(INI_READ_INT("Bug Fix","Transfered Crafts Refueled",0) || INI_READ_INT("Mod","Crafts Always Ready",0))
	{
//		044151F 66 C7 44 10 18 00 00    
		Nop(0x44151F,7);
	}

	if(INI_READ_INT("Bug Fix","Radar Stacking",0))
	{
		InsertJmp(0x439D10,FixRadarStacking);
	}

	if(INI_READ_INT("Bug Fix","Base Facility Dismantle-Construction Crash",0))
	{
		BaseFacilityDismantleConstructionCrash();
	}

	if(INI_READ_INT("Bug Fix","Tactical Scroll",0))
	{
		if(!INI_READ_INT("Mod","D3D",0)) //Useless with D3D
		{
			char patch_vsync[]={DDFLIP_WAIT};
			PatchInPlace(0x45C89D,patch_vsync,1); 
			InsertCall(0x4147D5,TimeFix);
			Nop(0x45C891,2); 
		}
	}

	if(INI_READ_INT("Bug Fix","Proximity Grenades",0)) 
	{
		InsertCall(0x42A7D6,FixProximityMines);
	}

	if(INI_READ_INT("Bug Fix","Proximity Grenades Experience",0))
	{
		InsertCall(0x41E239,FixProximityMinesExperience);
	}

	if(INI_READ_INT("Bug Fix","Pay For Dirt",0)) 
	{
		char patch[]={0xff, 0xff, 0xff, 0xff};
		PatchInPlace(0x43BE4E,patch,4);
	}

	if(INI_READ_INT("Bug Fix","Phantom Radar",0)) 
	{
		char patch[]={0xeb, 0x43A2D2-0x43A290-5};
		PatchInPlace(0x43A290,patch,2);
		InsertJmp(0x43A2D5,PhantomRadarFix);
	}

	if(INI_READ_INT("Bug Fix","Base Disjoint",0))
	{
		InsertCall(0x41AFCA,BaseDisjointFix);
	}
/////////////////Enhancements///////////////////
	
#ifdef NDEBUG
	if(INI_READ_INT("Mod","Save Reserve Mode",0)) 
#endif
	{
		InsertCall(0x401014,SaveReserveMode);
		InsertCall(0x4012F6,RestoreReserveMode);
	}

	if(INI_READ_INT("Mod","Hot Grenades",0)) 
	{
		Nop(0x41E095,6);
	}

	if(INI_READ_INT("Mod","Alien Inventory",0)) 
	{
		Nop(0x412A20,8);
	}

	if(INI_READ_INT("Mod","Retaliate Against Ground Assault",0)) 
	{
		InsertCall(0x44720A,RetaliationAfterGroundAssault);
	}

	if(INI_READ_INT("Mod","Rank In Inventory",0)) 
	{
		InsertCall(0x41A581,DrawRank);
		InsertCall(0x418E8C,DrawRank);
//		Nop(0x41A43E,2);
	}

	InsertCall(0x44A11F,ForceLanguage);

//////////////////Hacks////////////////////
	
#ifdef NDEBUG
	if(INI_READ_INT("Hack","No Score Game Over",0)) 
#endif
	{
		HackNoScoreGameOver();
	}

	if(INI_READ_INT("Hack","No Alien Psi",0)) 
	{
		HackNoAlienPsi();
	}

	if(INI_READ_INT("Hack","Directly Use Alien Weapons",0)) 
	{
		HackDirectlyUseAlienWeapons();
	}

	if(INI_READ_INT("Hack","Recover All Clips",0))
	{
		 HackRecoverAllClips();
	}

	if(INI_READ_INT("Hack","Show All Locations",0))
	{
		HackShowAllLocations();
	}

	InsertJmp(0x425455,HackDebugFlagsCheck);
}
